diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/startup.c
--- a/src/dep/startup.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/startup.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
@@ -39,6 +41,8 @@
 
 #include "../ptpd.h"
 
+PtpClock *ptpClock;
+
 /*
  * valgrind 3.5.0 currently reports no errors (last check: 20110512)
  * valgrind 3.4.1 lacks an adjtimex handler
@@ -70,6 +74,10 @@
 volatile sig_atomic_t	 sighup_received  = 0;
 volatile sig_atomic_t	 sigusr1_received = 0;
 volatile sig_atomic_t	 sigusr2_received = 0;
+#ifdef DBG_SIGRTMIN_LEAP_SECOND
+volatile sig_atomic_t	 sigrtmin0_received = 0;
+volatile sig_atomic_t	 sigrtmin1_received = 0;
+#endif
 
 /*
  * Function to catch signals asynchronously.
@@ -79,31 +87,38 @@
  */
 void catch_signals(int sig)
 {
-	switch (sig) {
-	case SIGINT:
+  switch (sig) {
+  case SIGINT:
 		sigint_received = 1;
 		break;
-	case SIGTERM:
+  case SIGTERM:
 		sigterm_received = 1;
-		break;
-	case SIGHUP:
-		sighup_received = 1;
-		break;
-	case SIGUSR1:
-		sigusr1_received = 1;
-		break;
-	case SIGUSR2:
-		sigusr2_received = 1;
-		break;
-	default:
-		/*
-		 * TODO: should all other signals be catched, and handled as SIGINT?
-		 *
-		 * Reason: currently, all other signals are just uncatched, and the OS kills us.
-		 * The difference is that we could then close the open files properly.
-		 */
-		break;
-	}
+    break;
+  case SIGHUP:
+    sighup_received = 1;
+    break;
+  case SIGUSR1:
+    sigusr1_received = 1;
+    break;
+  case SIGUSR2:
+    sigusr2_received = 1;
+    break;
+  default:
+#ifdef DBG_SIGRTMIN_LEAP_SECOND
+    if (sig == SIGRTMIN + 0)
+      sigrtmin0_received = 1;
+    else if (sig == SIGRTMIN + 1)
+      sigrtmin1_received = 1;
+    else
+#endif
+      /*
+       * TODO: should all other signals be catched, and handled as SIGINT?
+       *
+       * Reason: currently, all other signals are just uncatched, and the OS kills us.
+       * The difference is that we could then close the open files properly.
+       */
+    break;
+  }
 }
 
 
@@ -119,12 +134,12 @@
 	exit(0);
 }
 
-/** 
+/**
  * Signal handler for HUP which tells us to swap the log file.
  * 
  * @param sig 
  */
-void 
+void
 do_signal_sighup(RunTimeOpts * rtOpts)
 {
 	if(rtOpts->do_record_quality_file)
@@ -135,7 +150,7 @@
 		if(!logToFile(rtOpts))
 			NOTIFY("SIGHUP logToFile failed\n");
 
-	NOTIFY("I've been SIGHUP'd\n");
+  NOTIFY("I've been SIGHUP'd\n");
 }
 
 
@@ -146,10 +161,10 @@
 void
 check_signals(RunTimeOpts * rtOpts, PtpClock * ptpClock)
 {
-	/*
-	 * note:
-	 * alarm signals are handled in a similar way in dep/timer.c
-	 */
+  /*
+  * note:
+  * alarm signals are handled in a similar way in dep/timer.c
+  */
 
 	if(sigint_received || sigterm_received){
 		do_signal_close(ptpClock);
@@ -158,42 +173,80 @@
 	if(sighup_received){
 		do_signal_sighup(rtOpts);
 	sighup_received=0;
+  }
+
+  if(sigusr1_received){
+    WARNING("SigUSR1 received, manually stepping clock to current known OFM\n");
+    /* If the time mode is time both then step the NIC clock and system clock.
+     * Do the time both clock first because this requires the clock to be stepped
+     * by the sum of the two servo's current offset and the offset is cleared by
+     * the clock step process */
+    if (rtOpts->time_mode == TIME_BOTH) {
+      TimeInternal offset;
+      extern PtpClock *G_timeBothClock;
+      extern RunTimeOpts *G_timeBothRtOpts;
+      addTime(&offset, &ptpClock->offsetFromMaster, &G_timeBothClock->offsetFromMaster);
+      servo_perform_clock_step(G_timeBothRtOpts, G_timeBothClock, &offset);
+    }
+    servo_perform_clock_step(rtOpts, ptpClock, &ptpClock->offsetFromMaster);
+  sigusr1_received = 0;
+  }
+
+
+#ifdef DBG_SIGUSR2_CHANGE_DOMAIN
+  if(sigusr2_received){
+    /* swap domain numbers */
+    static int prev_domain;
+    static int first_time = 1;
+    if(first_time){
+      first_time = 0;
+      prev_domain = ptpClock->domainNumber + 1;
+    }
+
+    int  temp = ptpClock->domainNumber;
+    ptpClock->domainNumber = prev_domain;
+    prev_domain = temp;
+
+
+    // propagate new choice as the run-time option
+    rtOpts->domainNumber = ptpClock->domainNumber;
+
+    WARNING("SigUSR2 received. PTP_Domain is now %d  (saved: %d)\n",
+      ptpClock->domainNumber,
+      prev_domain
+    );
+  sigusr2_received = 0;
+  }
+#endif
+
+
+#ifdef DBG_SIGRTMIN_LEAP_SECOND
+	if (sigrtmin0_received && (rtOpts->master_slave_mode != PTP_MODE_SLAVE)) {
+		ptpClock->leap61 = TRUE;
+		ptpClock->leap59 = FALSE;
+		timerStop(LEAP_SECOND_NOW_TIMER, ptpClock->itimer);
+		timerStart(LEAP_SECOND_NOW_TIMER,
+			   secondsToMidnight() + (float)ptpClock->currentUtcOffset,
+			   ptpClock->itimer);
+		
+		INFO("Signalling leap second 61 at end of current day\n");
+		sigrtmin0_received = 0;
 	}
 
-	if(sigusr1_received){
-		WARNING("SigUSR1 received, manually stepping clock to current known OFM\n");
-		servo_perform_clock_step(rtOpts, ptpClock);
-	sigusr1_received = 0;
-	}
+	if (sigrtmin1_received && (rtOpts->master_slave_mode != PTP_MODE_SLAVE)) {
+		ptpClock->leap59 = TRUE;
+		ptpClock->leap61 = FALSE;
+		
+		timerStop(LEAP_SECOND_NOW_TIMER, ptpClock->itimer);
+		timerStart(LEAP_SECOND_NOW_TIMER,
+			   secondsToMidnight() + (float)ptpClock->currentUtcOffset - 1.0,
+			   ptpClock->itimer);
 
-
-#ifdef DBG_SIGUSR2_CHANGE_DOMAIN
-	if(sigusr2_received){
-		/* swap domain numbers */
-		static int prev_domain;
-		static int first_time = 1;
-		if(first_time){
-			first_time = 0;
-			prev_domain = ptpClock->domainNumber + 1;
-		}
-
-		int  temp = ptpClock->domainNumber;
-		ptpClock->domainNumber = prev_domain;
-		prev_domain = temp;
-
-		
-		// propagate new choice as the run-time option
-		rtOpts->domainNumber = ptpClock->domainNumber;
-		
-		WARNING("SigUSR2 received. PTP_Domain is now %d  (saved: %d)\n",
-			ptpClock->domainNumber,
-			prev_domain
-		);
-		sigusr2_received = 0;
+		INFO("Signalling leap second 59 at end of current day\n");
+		sigrtmin1_received = 0;
 	}
 #endif
 
-		
 #ifdef DBG_SIGUSR2_CHANGE_DEBUG
 #ifdef RUNTIME_DEBUG
 	if(sigusr2_received){
@@ -242,8 +295,8 @@
 #include <sys/stat.h>
 #include <libgen.h>
 
-#define LOCKFILE "/var/run/kernel_clock"
-#define LOCKMODE (S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)
+#define LOCKFILE "/system/volatile/ptpd.pid"
+#define LOCKMODE (S_IRUSR|S_IWUSR)
 
 int global_lock_fd;
 
@@ -261,6 +314,31 @@
 	return(fcntl(fd, F_SETLK, &fl));
 }
 
+int
+get_owner_lockfile(int fd)
+{
+	struct flock fl;
+
+	fl.l_type = F_WRLCK;
+	fl.l_start = 0;
+	fl.l_whence = SEEK_SET;
+	fl.l_len = 0;
+	if (fcntl(fd, F_GETLK, &fl) == 0) {
+		return(fl.l_pid);
+	}
+	return 0;
+}
+
+int
+unlockfile(int fd) {
+	struct flock fl;
+
+	fl.l_type = F_UNLCK;
+	fl.l_start = 0;
+	fl.l_whence = SEEK_SET;
+	fl.l_len = 0;
+	return(fcntl(fd, F_SETLK, &fl));
+}
 
 /*
  * a discussion where the lock file should reside: http://rute.2038bug.com/node38.html.gz#SECTION003859000000000000000
@@ -268,33 +346,37 @@
 int
 daemon_already_running(void)
 {
-	char    buf[16];
+  char    buf[16];
+  int lpid;
 
 	INFO("  Info:    Going to check lock %s\n", LOCKFILE);
-	global_lock_fd = open(LOCKFILE, O_RDWR|O_CREAT, LOCKMODE);
-	if (global_lock_fd < 0) {
-		syslog(LOG_ERR, "can't open %s: %s", LOCKFILE, strerror(errno));
-		PERROR("can't open %s: %s", LOCKFILE, strerror(errno));
-		exit(1);
-	}
-	if (lockfile(global_lock_fd) < 0) {
-		if (errno == EACCES || errno == EAGAIN) {
-			close(global_lock_fd);
-			return(1);
-		}
-		syslog(LOG_ERR, "can't lock %s: %s", LOCKFILE, strerror(errno));
-		PERROR("can't lock %s: %s", LOCKFILE, strerror(errno));
-		return(1);
-	}
-	ftruncate(global_lock_fd, 0);
-	sprintf(buf, "%ld\n", (long)getpid());
-	write(global_lock_fd, buf, strlen(buf)+1);
-	return(0);
+  global_lock_fd = open(LOCKFILE, O_RDWR|O_CREAT, LOCKMODE);
+  if (global_lock_fd < 0) {
+    syslog(LOG_ERR, "can't open %s: %s", LOCKFILE, strerror(errno));
+    PERROR("can't open %s: %s", LOCKFILE, strerror(errno));
+    //ptpdShutdown(FALSE);
+    exit(1);
+  }
+  if (lockfile(global_lock_fd) < 0) {
+    if (errno == EACCES || errno == EAGAIN) {
+	lpid = get_owner_lockfile(global_lock_fd);
+	syslog(LOG_ERR, "%s locked by %d", LOCKFILE, lpid);
+	PERROR("%s locked by %d", LOCKFILE, lpid);
+      close(global_lock_fd);
+      return(1);
+    }
+    syslog(LOG_ERR, "can't lock %s: %s", LOCKFILE, strerror(errno));
+    PERROR("can't lock %s: %s", LOCKFILE, strerror(errno));
+    return(1);
+  }
+  ftruncate(global_lock_fd, 0);
+  sprintf(buf, "%ld\n", (long)getpid());
+  write(global_lock_fd, buf, strlen(buf)+1);
+  return(0);
 }
 
 
 
-
 int query_shell(char *command, char *answer, int answer_size);
 
 
@@ -310,14 +392,17 @@
 	char command[BUF_SIZE];
 	char answer[BUF_SIZE];
 	int matches;
+	int mypid;
 
-	snprintf(command, BUF_SIZE - 1, "pgrep -x %s | wc -l", name);
+	mypid = getpid();
+	snprintf(command, BUF_SIZE - 1, "pgrep -x %s | grep -v %d | wc -l", name, mypid);
 
 	if( query_shell(command, answer, BUF_SIZE) < 0){
 		return -1;
 	};
 	
 	sscanf(answer, "%d", &matches);
+
 	return (matches);
 }
 
@@ -333,32 +418,32 @@
  */
 int query_shell(char *command, char *answer, int answer_size)
 {
-	int status;
-	FILE *fp;
+  int status;
+  FILE *fp;
 
 	// clear previous answer
 	answer[0] = '\0';
 
 	fp = popen(command, "r");
-	if (fp == NULL){
+  if (fp == NULL){
 		PERROR("can't call  %s", command);
-		return -1;
-	};
+    return -1;
+  };
 
 	// get first line of popen
 	fgets(answer, answer_size - 1, fp);
 
 	DBG2("Query_shell: _%s_ -> _%s_\n", command, answer);
 
-	status = pclose(fp);
-	if (status == -1) {
-		PERROR("can't call pclose() ");
-		return -1;
-	} 
+  status = pclose(fp);
+  if (status == -1) {
+    PERROR("can't call pclose() ");
+    return -1;
+  }
 
-	/* from Man page:
-	     Use macros described under wait() to inspect `status' in order
-	     to determine success/failure of command executed by popen() */
+  /* from Man page:
+      Use macros described under wait() to inspect `status' in order
+      to determine success/failure of command executed by popen() */
 
 	return 0;
 }
@@ -375,38 +460,38 @@
 int
 check_parallel_daemons(char *name, int expected, int strict, RunTimeOpts * rtOpts)
 {
-	int matches = pgrep_matches(name);
+  int matches = pgrep_matches(name);
 
-	if(matches == expected){
-		if(!expected){
-			INFO(       "  Info:    No %s daemons detected in parallel (as expected)\n",
-				name );
-		} else {
-			INFO(       "  Info:    %d %s daemons detected in parallel (as expected)\n",
-				matches, name);
-		}
-		return 1;
+  if(matches == expected){
+	if(!expected){
+		INFO(       "  Info:    No %s daemons detected in parallel (as expected)\n",
+			name );
 	} else {
-		if(strict){
-			if(expected == 0){
-				ERROR(  "  Error:   %d %s daemon(s) detected in parallel, but we were not expecting any. Exiting.\n",
-				   matches, name);
-			} else {
-				ERROR(  "  Error:   %d %s daemon(s) detected in parallel, but we were expecting %d. Exiting.\n",
-				   matches, name, expected);
-			}
-			return 0;
-		} else {
-			if(!expected){
-				WARNING("  Warning: %d %s daemon(s) detected in parallel, but we were expected none. Continuing anyway.\n",
-				   matches, name);
-			} else {
-				WARNING("  Warning: %d %s daemon(s) detected in parallel, but we were expecting %d. Continuing anyway.\n",
-				   matches, name, expected);
-			}
-			return 1;
-		}
+		INFO(       "  Info:    %d %s daemons detected in parallel (as expected)\n",
+			matches, name);
 	}
+    return 1;
+  } else {
+    if(strict){
+	if(expected == 0){
+		ERROR(  "  Error:   %d %s daemon(s) detected in parallel, but we were not expecting any. Exiting.\n",
+		    matches, name);
+	} else {
+		ERROR(  "  Error:   %d %s daemon(s) detected in parallel, but we were expecting %d. Exiting.\n",
+          matches, name, expected);
+	}
+      return 0;
+    } else {
+	if(!expected){
+		WARNING("  Warning: %d %s daemon(s) detected in parallel, but we were expected none. Continuing anyway.\n",
+		   matches, name);
+	} else {
+		WARNING("  Warning: %d %s daemon(s) detected in parallel, but we were expecting %d. Continuing anyway.\n",
+            matches, name, expected);
+	}
+      return 1;
+    }
+  }
 }
 
 
@@ -417,28 +502,28 @@
 
 
 
-/** 
+/**
  * Log output to a file
  * 
  * 
  * @return True if success, False if failure
  */
-int 
+int
 logToFile(RunTimeOpts * rtOpts)
 {
 	if(rtOpts->logFd != -1)
 		close(rtOpts->logFd);
-	
 
-	/* We new append the file instead of replacing it. Also use mask 644 instead of 444 */
+
+  /* We new append the file instead of replacing it. Also use mask 644 instead of 444 */
 	if((rtOpts->logFd = open(rtOpts->file, O_CREAT | O_APPEND | O_RDWR, 0644 )) != -1) {
 		dup2(rtOpts->logFd, STDOUT_FILENO);
 		dup2(rtOpts->logFd, STDERR_FILENO);
-	}
+  }
 	return rtOpts->logFd != -1;
 }
 
-/** 
+/**
  * Record quality data for later correlation
  * 
  * 
@@ -451,63 +536,82 @@
 		fclose(rtOpts->recordFP);
 
 	if ((rtOpts->recordFP = fopen(rtOpts->recordFile, "w")) == NULL)
-		PERROR("could not open sync recording file");
-	else
+    PERROR("could not open sync recording file");
+  else
 		setlinebuf(rtOpts->recordFP);
 	return (rtOpts->recordFP != NULL);
 }
 
-void 
+void
 ptpdShutdown(PtpClock * ptpClock)
 {
-	netShutdown(&ptpClock->netPath);
+  shutdownTime(ptpClock);
+  netShutdown(&ptpClock->netPath);
 
-	
+
 	free(ptpClock->foreign);
 	free(ptpClock);
 
-	/* properly clean lockfile (eventough new deaemons can adquire the lock after we die) */
-	close(global_lock_fd);
-	unlink(LOCKFILE);
+#if 0
+  /* Don't call free if we are in the context of the signal handler */
+  if (!inSigHandler) {
+    free(ptpClock->foreign);
+    free(ptpClock);
+  }
+#endif
+
+  /* properly clean lockfile (even though new deaemons can acquire the lock after we die) */
+  close(global_lock_fd);
+  unlink(LOCKFILE);
 }
 
 void dump_command_line_parameters(int argc, char **argv)
 {
 	//
 	int i = 0;
-	char sbuf[1000];
-	char *st = sbuf;
-	int len = 0;
-	
-	*st = '\0';
-	for(i=0; i < argc; i++){
-		len += snprintf(sbuf + len,
-					     sizeof(sbuf) - len,
-					     "%s ", argv[i]);
+  char sbuf[1000];
+  char *st = sbuf;
+  int len = 0;
+
+  *st = '\0';
+  for(i=0; i < argc; i++){
+    if (len >= sizeof(sbuf)) {
+      ERROR("command line too long, %d\n", len);
+      return;
+    } else {
+      len += snprintf(sbuf + len,
+		      sizeof(sbuf) - len,
+		      "%s ", argv[i]);
+    }
+  }
+
+  INFO("\n");
+  INFO("Starting ptpd daemon with parameters:      %s\n", sbuf);
+}
+
+
+void
+display_short_help(char *msg, Boolean error)
+{
+	char *ermsg;
+	if (error) {
+		ermsg = "ERROR";
+	} else {
+		ermsg = "";
 	}
 
-	INFO("\n");
-	INFO("Starting ptpd2 daemon with parameters:      %s\n", sbuf);
-}
-
-
-void
-display_short_help(char *error)
-{
 	printf(
-			//"\n"
-			"ptpd2:\n"
-			"   -gGW          Protocol mode (slave/master with ntp/master without ntp)\n"
+			"ptpd:\n"
+			"   -gW          Protocol mode (slave/master)\n"
 			"   -b <dev>      Interface to use\n"
 			"\n"
 			"   -cC  -DVfS    Console / verbose console;     Dump stats / Interval / Output file / no Syslog\n"
 			"   -uU           Unicast/Hybrid mode\n"
 			"\n"
 			"\n"
-			"   -hHB           Summary / Complete help file / run-time debug level\n"
+			"   -?HB           Summary / Complete help file / run-time debug level\n"
 			"\n"
-			"ERROR: %s\n\n",
-			error
+			"%s %s\n\n", ermsg, msg
 		);
 }
 
@@ -517,166 +621,188 @@
 ptpdStartup(int argc, char **argv, Integer16 * ret, RunTimeOpts * rtOpts)
 {
 	PtpClock * ptpClock;
-	int c, noclose = 0;
-	int mode_selected = 0;		// 1: slave / 2: master, with ntp / 3: master without ntp
+  int c, noclose = 0;
+  int mode_selected = 0;		// 1: slave / 2: master, with ntp / 3: master without ntp
 
-	int ntp_daemons_expected = 0;
-	int ntp_daemons_strict = 1;
-	int ptp_daemons_expected = 0;
-	int ptp_daemons_strict = 1;
+  int ntp_daemons_expected = 0;
+  int ntp_daemons_strict = 1;
+  int ptp_daemons_expected = 0;
+  int ptp_daemons_strict = 1;
 
-	dump_command_line_parameters(argc, argv);
+  Boolean time_mode_specified = FALSE;
+  TimeMode default_time_mode;
+  Boolean use_hardware_assist = FALSE;
+  Boolean is_error;
 
-	const char *getopt_string = "HgGWb:cCf:ST:dDPR:xO:tM:a:w:u:Uehzl:o:i:I:n:N:y:m:v:r:s:p:q:Y:BjLV:";
+  dump_command_line_parameters(argc, argv);
+/*
+#ifdef PTPD_FULL_OPTIONS
+  const char *getopt_string = "HcSdDEPf:R:X:B:txjO:M:a:w:b:l:T:u:o:i:n:y:m:v:r:s:p:q:Y:LZgGWK";
+#else
+  const char *getopt_string = "HcSdDEPf:R:X:B:txjM:a:w:b:l:T:o:i:n:y:m:v:r:s:p:q:Y:LZgGWK";
+#endif
+*/
 
-	/* parse command line arguments */
-	while ((c = getopt(argc, argv, getopt_string)) != -1) {
-		switch (c) {
-		case '?':
-			printf("\n");
-			display_short_help("Please input correct parameters (use -H for complete help file)");
-			*ret = 1;
-			return 0;
-			break;
-			
-		case 'H':
-			printf(
-				"\nUsage:  ptpv2d [OPTION]\n\n"
-				"Ptpv2d runs on UDP/IP , E2E mode by default\n"
+   const char *getopt_string = "?HgGWb:cCf:ST:dDPR:xO:tM:a:w:u:ehzl:o:i:n:N:y:m:v:r:s:p:q:Y:BjLV:XZK";
+
+  /* parse command line arguments */
+  while ((c = getopt(argc, argv, getopt_string)) != -1) {
+    switch (c) {
+    case '?':
+      if (optopt == '?') {
+	      is_error = FALSE;
+	      *ret = 0;
+      } else {
+	      is_error = TRUE;
+	      *ret = 1;
+      }
+      printf("\n");
+      display_short_help("Please input correct parameters (use -H for complete help file)", is_error);
+      return 0;
+      break;
+
+    case 'H':
+      printf(
+				"\nUsage:  ptpd [OPTION]\n\n"
+				"ptpd runs on UDP/IP , E2E mode by default\n"
+        "\n"
+#define GETOPT_START_OF_OPTIONS
+	"-H                show detailed help page\n"
 				"\n"
-#define GETOPT_START_OF_OPTIONS
-				"-H                show detailed help page\n"
+        "Mode selection (one option is always required):\n"
+        "-g                run as slave only\n"
+        "-W                run as a Master _without_ NTP (reverts to client when inactive)\n"
+        "-b NAME           bind PTP to network interface NAME\n"
 				"\n"
-				"Mode selection (one option is always required):\n"
-				"-g                run as slave only\n"
-				"-G                run as a Master _with_ NTP  (implies -t -L)\n"
-				"-W                run as a Master _without_ NTP (reverts to client when inactive)\n"
-				"-b NAME           bind PTP to network interface NAME\n"
+	"Options:\n"
+	"-c                run in command line (non-daemon) mode (implies -D)\n"
+	"-C                verbose non-daemon mode: implies -c -S -D -V 0, disables -f\n"
+	"-f FILE           send output to FILE (implies -D)\n"
+        "-S                DON'T send messages to syslog\n"
 				"\n"
-				"Options:\n"
-				"-c                run in command line (non-daemon) mode (implies -D)\n"
-				"-C                verbose non-daemon mode: implies -c -S -D -V 0, disables -f\n"
-				"-f FILE           send output to FILE (implies -D)\n"
-				"-S                DON'T send messages to syslog\n"
+        "-T NUMBER         set multicast time to live\n"
+	"-d                display stats (per received packet, see also -V)\n"
+	"-D                display stats in .csv format (per received packet, see also -V)\n"
+	"-P                display each received packet in detail\n"
+	"-R FILE           record data about sync packets in a seperate file\n"
 				"\n"
-				"-T NUMBER         set multicast time to live\n"
-				"-d                display stats (per received packet, see also -V)\n"
-				"-D                display stats in .csv format (per received packet, see also -V)\n"
-				"-P                display each received packet in detail\n"
-				"-R FILE           record data about sync packets in a seperate file\n"
+	"-x                do not reset the clock if off by more than one second\n"
+	"-O NUMBER         do not reset the clock if offset is more than NUMBER nanoseconds\n"
+
+	"-t                do not make any changes to the system clock\n"
+	"-M NUMBER         do not accept delay values of more than NUMBER nanoseconds\n"
+	"-a 10,1000        specify clock servo Proportional and Integral attenuations\n"
+	"-w NUMBER         specify one way delay filter stiffness\n"
 				"\n"
-				"-x                do not reset the clock if off by more than one second\n"
-				"-O NUMBER         do not reset the clock if offset is more than NUMBER nanoseconds\n"
+	"-K                use PTP hardware in network interface. Exit if\n"
+	"                  PTP hardware is not usable or available.\n"
+	"-u ADDRESS        Unicast mode: send all messages in unicast to ADDRESS\n"
+	"-U                Hybrid  mode: send DELAY messages in unicast\n"
+	"                    This causes all delayReq messages to be sent in unicast to the\n"
+	"                    IP address of the Master (taken from the last announce received).\n"
+	"                    For masters, it replyes the delayResp to the IP address of the client\n"
+	"                    (from the corresponding delayReq message).\n"
+	"                    All other messages are send in multicast\n"
+				"\n"
+	"-e                run in ethernet mode (level2) \n"
+	"-h                run in End to End mode \n"
+	"-z                run in Peer-delay mode\n"
+	"-l NUMBER,NUMBER  specify inbound, outbound latency in nsec.\n"
+	"                    (Use this to compensate the time it takes to send and recv\n"
+	"                    messages via sockets)\n"
+			"\n"
+	"-o NUMBER         specify current UTC offset\n"
+	"-i NUMBER         specify PTP domain number (between 0-3)\n"
+	"-I NUMBER         specify Mcast group (between 0-3, emulates PTPv1 group selection)\n"
 
-				"-t                do not make any changes to the system clock\n"
-				"-M NUMBER         do not accept delay values of more than NUMBER nanoseconds\n"
-				"-a 10,1000        specify clock servo Proportional and Integral attenuations\n"
-				"-w NUMBER         specify one way delay filter stiffness\n"
 				"\n"
-				"-u ADDRESS        Unicast mode: send all messages in unicast to ADDRESS\n"
-				"-U                Hybrid  mode: send DELAY messages in unicast\n"
-				"                    This causes all delayReq messages to be sent in unicast to the\n"
-				"                    IP address of the Master (taken from the last announce received).\n"
-				"                    For masters, it replyes the delayResp to the IP address of the client\n"
-				"                    (from the corresponding delayReq message).\n"
-				"                    All other messages are send in multicast\n"
+	"-n NUMBER         specify announce interval in seconds\n"
+	"-N NUMBER         specify announce receipt TO (number of lost announces to timeout)\n"
+
+       	"-y NUMBER         specify sync interval in seconds\n"
+	"-m NUMBER         specify max number of foreign master records\n"
 				"\n"
-				"-e                run in ethernet mode (level2) \n"
-				"-h                run in End to End mode \n"
-				"-z                run in Peer-delay mode\n"
-				"-l NUMBER,NUMBER  specify inbound, outbound latency in nsec.\n"
-				"                    (Use this to compensate the time it takes to send and recv\n"
-				"                    messages via sockets)\n"
+        "-v NUMBER         Master mode: specify system clock Allen variance\n"
+        "-r NUMBER         Master mode: specify system clock accuracy\n"
+        "-s NUMBER         Master mode: specify system clock class\n"
+        "-p NUMBER         Master mode: specify priority1 attribute\n"
+        "-q NUMBER         Master mode: specify priority2 attribute\n"
+		"\n"
+		"\n"
+	"-Y 0[,0]          Initial and Master_Overide delayreq intervals\n"
+	"                     desc: the first 2^ number is the rate the slave sends delayReq\n"
+	"                     When the first answer is received, the master value is used (unless the\n"
+	"                     second number was also given)\n"
+		"\n"
+	"-B                Enable debug messages (if compiled-in). Multiple invocations to more debug\n"
+		"\n"
+	"Compatibility Options (to restore previous default behaviour):\n"
+	"-j                Do not refresh the IGMP Multicast menbership at each protol reset\n"
+	"-L                Allow multiple instances (ignore lock and other daemons)\n"
+	"-V 0              Seconds between log messages (0: all messages)\n"
 				"\n"
-				"-o NUMBER         specify current UTC offset\n"
-				"-i NUMBER         specify PTP domain number (between 0-3)\n"
-				"-I NUMBER         specify Mcast group (between 0-3, emulates PTPv1 group selection)\n"
-				
 				"\n"
-				"-n NUMBER         specify announce interval in 2^NUMBER sec\n"
-				"-N NUMBER         specify announce receipt TO (number of lost announces to timeout)\n"
-
-				"-y NUMBER         specify sync interval in 2^NUMBER sec\n"
-				"-m NUMBER         specify max number of foreign master records\n"
-				"\n"
-				"-v NUMBER         Master mode: specify system clock Allen variance\n"
-				"-r NUMBER         Master mode: specify system clock accuracy\n"
-				"-s NUMBER         Master mode: specify system clock class\n"
-				"-p NUMBER         Master mode: specify priority1 attribute\n"
-				"-q NUMBER         Master mode: specify priority2 attribute\n"
-				"\n"
-				"\n"
-				"-Y 0[,0]          Initial and Master_Overide delayreq intervals\n"
-				"                     desc: the first 2^ number is the rate the slave sends delayReq\n"
-				"                     When the first answer is received, the master value is used (unless the\n"
-				"                     second number was also given)\n"
-				"\n"
-				"-B                Enable debug messages (if compiled-in). Multiple invocations to more debug\n"
-				"\n"
-				"Compatibility Options (to restore previous default behaviour):\n"
-				"-j                Do not refresh the IGMP Multicast menbership at each protol reset\n"
-				"-L                Allow multiple instances (ignore lock and other daemons)\n"
-				"-V 0              Seconds between log messages (0: all messages)\n"
-				"\n"
-				"\n"
+	"-Z                ignore delayReq interval given by Master\n"
 
 
 #define GETOPT_END_OF_OPTIONS
 				"\n"
-				"Possible internal states:\n"
-				"  init:        INITIALIZING\n"
-				"  flt:         FAULTY\n"
-				"  lstn_init:   LISTENING (first time)\n"
-				"  lstn_reset:  LISTENING (non first time)\n"
-				"  pass:        INACTIVE Master\n"
-				"  uncl:        UNCALIBRATED\n"
-				"  slv:         SLAVE\n"
-				"  pmst:        PRE Master\n"
-				"  mst:         ACTIVE Master\n"
-				"  dsbl:        DISABLED\n"
-				"  ?:           UNKNOWN state\n"
+	"Possible internal states:\n"
+	"  init:        INITIALIZING\n"
+	"  flt:         FAULTY\n"
+	"  lstn_init:   LISTENING (first time)\n"
+	"  lstn_reset:  LISTENING (non first time)\n"
+	"  pass:        INACTIVE Master\n"
+	"  uncl:        UNCALIBRATED\n"
+	"  slv:         SLAVE\n"
+	"  pmst:        PRE Master\n"
+	"  mst:         ACTIVE Master\n"
+	"  dsbl:        DISABLED\n"
+	"  ?:           UNKNOWN state\n"
 
-				"\n"
+			"\n"
 
-				"Signals synchronous behaviour:\n"
-				"  SIGHUP         Re-open statistics log (specified with -f)\n"
-				"  SIGUSR1        Manually step clock to current OFM value (overides -x, but honors -t)\n"
-				"  SIGUSR2        swap domain between current and current + 1 (useful for testing)\n"
-				"  SIGUSR2        cycle run-time debug level (requires RUNTIME_DEBUG)\n"
-				"\n"
-				"  SIGINT|TERM    close file, remove lock file, and clean exit\n"
-				"  SIGKILL|STOP   force an unclean exit\n"
-				
-				"\n"
-				"BMC Algorithm defaults:\n"
-				"  Software:   P1(128) > Class(13|248) > Accuracy(\"unk\"/0xFE)   > Variance(61536) > P2(128)\n"
+        "Signals synchronous behaviour:\n"
+	"  SIGHUP         Re-open statistics log (specified with -f)\n"
+	"  SIGUSR1        Manually step clock to current OFM value (overides -x, but honors -t)\n"
+	"  SIGUSR2        swap domain between current and current + 1 (useful for testing)\n"
+	"  SIGUSR2        cycle run-time debug level (requires RUNTIME_DEBUG)\n"
+#ifdef DBG_SIGRTMIN_LEAP_SECOND
+	"  SIGRTMIN       Master: signal a leap second 61 at the end of the current UTC day\n"
+	"  SIGRTMIN+1     Master- signal a leap second 59 at the end of the current UTC day\n"
+#endif
+        "\n"
+        "  SIGINT|TERM    close file, remove lock file, and clean exit\n"
+        "  SIGKILL|STOP   force an unclean exit\n"
 
-											 
-				/*  "-k NUMBER,NUMBER  send a management message of key, record, then exit\n" implemented later.. */
-			    "\n"
-			    );
-			*ret = 1;
-			return 0;
-			break;
+        "\n"
+        "BMC Algorithm defaults:\n"
+        "  Software:   P1(248) > Class(13|248) > Accuracy(\"unk\"/0xFE)   > Variance(61536) > P2(0)\n\nptpd version %s\n",
 
-		case 'c':
-			rtOpts->nonDaemon = 1;
-			break;
+        PTP_VERSION_STRING
+        );
+      *ret = 0;
+      return 0;
+      break;
+
+    case 'c':
+      rtOpts->nonDaemon = 1;
+      break;
 			
-		case 'C':
-			rtOpts->nonDaemon = 2;
+    case 'C':
+	rtOpts->nonDaemon = 2;
 
-			rtOpts->useSysLog    = FALSE;
-			rtOpts->syslog_startup_messages_also_to_stdout = TRUE;
-			rtOpts->displayStats = TRUE;
-			rtOpts->csvStats     = TRUE;
-			rtOpts->log_seconds_between_message = 0;
-			rtOpts->do_log_to_file = FALSE;
-			break;
-			
-		case 'S':
-			rtOpts->useSysLog = FALSE;
-			break;
+	rtOpts->useSysLog    = FALSE;
+	rtOpts->syslog_startup_messages_also_to_stdout = TRUE;
+	rtOpts->displayStats = TRUE;
+	rtOpts->csvStats     = TRUE;
+	rtOpts->log_seconds_between_message = 0;
+	rtOpts->do_log_to_file = FALSE;
+	break;
+	
+    case 'S':
+      rtOpts->useSysLog = FALSE;
+      break;
 		case 'T':
 			rtOpts->ttl = atoi(optarg);
 			break;
